// Utility functions for clustering algorithms.

# include <stdio.h>
# include <stdlib.h>
# include <math.h>
# include "cluster.h"
# define inf 1000000


// Convert the (i,j) index into the single index in the data of graph.txt
long conv_ind(long i, long j, long N)
{
  long k, count;
  
  if (i==j)
    {
      count=-1;
      return count;
    }

  count=0;
  if (i<j)
    {
      for (k=(N-1); k>=(N-i); k--)
	count+=k;
      count+=(j-i-1);
    }
  else
    {
      for (k=(N-1); k>=(N-j); k--)
	count+=k;
      count+=(i-j-1);
    }

  return count;
}

// Convert the single index into the (i,j) index.
long *inv_conv_ind(long count, long N)
{
  long *pa, i=0, j;
  long acc=N-1;

  //printf("count=%i i=%i acc=%i ",count,i,acc);
  while (count>(acc-1))
    {
      //printf("count=%i i=%i acc=%i ",count,i,acc);
      i++;
      acc+=(N-1-i);
    }
  acc-=(N-1-i);
  j=count-acc+i+1;

  pa=malloc(sizeof(long)*2);
  *pa=i; *(pa+1)=j;
  return pa;
}

// Compare two long integers.  Return -1 if l1>l2, 0 if l1=l2, 1 if l1<l2.
int long_cmp(long *l1, long *l2)
{
  int cmp;
  
  if (*l1>*l2)
    cmp=-1;
  else if (*l1<*l2)
    cmp=1;
  else
    cmp=0;

  return cmp;
}

// Compare two long integers.  Return -1 if l1<l2, 0 if l1=l2, 1 if l1>l2.
int asc_long_cmp(long *l1, long *l2)
{
  int cmp;
  
  if (*l1<*l2)
    cmp=-1;
  else if (*l1>*l2)
    cmp=1;
  else
    cmp=0;

  return cmp;
}

// Compare two real numbers.  Return -1 if l1>l2, 0 if l1=l2, 1 if l1<l2.
int double_cmp(double *l1, double *l2)
{
  int cmp;
  
  if (*l1>*l2)
    cmp=-1;
  else if (*l1<*l2)
    cmp=1;
  else
    cmp=0;

  return cmp;
}
   
      
// Compare two pair structure variables p1 and p2.  Return -1 if p1.s>p2.s, 0 if p1.s=p2.s, 1 if p1.s<p2.s.  Reverse the order because the qsort function arranges the elements in ascending order, but we need them in descending order.

int pair_cmp(struct pair *p1, struct pair *p2)
{
  int cmp;

  if ((p1->s)>(p2->s))
    cmp=-1;
  else if ((p1->s)<(p2->s))
    cmp=1;
  else
    cmp=0;

  return cmp;
}

// Compare two node structure variables n1 and n2.  Return -1 if n1.s>n2.s, 0 if n1.s=n2.s, 1 if n1.s<n2.s.  Reverse the order because the qsort function arranges the elements in ascending order, but we need them in descending order.

int node_cmp(struct node *n1, struct node *n2)
{
  int cmp;

  if ((n1->s)>(n2->s))
    cmp=-1;
  else if ((n1->s)<(n2->s))
    cmp=1;
  else
    cmp=0;

  return cmp;
}

// Compare two triplet structure variables p1 and p2.  Return -1 if p1.s>p2.s, 0 if p1.s=p2.s, 1 if p1.s<p2.s.  Reverse the order because the qsort function arranges the elements in ascending order, but we need them in descending order.

int triplet_cmp(struct triplet *p1, struct triplet *p2)
{
  int cmp;

  if ((p1->s)>(p2->s))
    cmp=-1;
  else if ((p1->s)<(p2->s))
    cmp=1;
  else
    cmp=0;

  return cmp;
}

// Compare two pair2 structure variables p1 and p2. Return -1 if p1.s1>p2.s1, 0 if p1.s1=p2.s1, 1 if p1.s1<p2.s1.  Reverse the order because the qsort function arranges the elements in ascending order, but we need them in descending order. 

int pair2_cmp1(struct pair2 *p1, struct pair2 *p2)
{
  int cmp;

  if ((p1->s1)>(p2->s1))
    cmp=-1;
  else if ((p1->s1)<(p2->s1))
    cmp=1;
  else
    cmp=0;

  return cmp;
}


// Compare two pair2 structure variables p1 and p2. Return -1 if p1.s2>p2.s2, 0 if p1.s2=p2.s2, 1 if p1.s2<p2.s2.  Reverse the order because the qsort function arranges the elements in ascending order, but we need them in descending order. 

int pair2_cmp2(struct pair2 *p1, struct pair2 *p2)
{
  int cmp;

  if ((p1->s2)>(p2->s2))
    cmp=-1;
  else if ((p1->s2)<(p2->s2))
    cmp=1;
  else
    cmp=0;

  return cmp;
}


// Find out the maximum entry of an array of pair variables.

struct pair *max_pair(struct pair *parray, int N)
{
  struct pair *retp;
  int n;

  retp=malloc(sizeof(struct pair));
  retp->i=parray->i; retp->j=parray->j; retp->s=parray->s;

  for (n=1; n<=(N-1); n++)
    {
      if (((parray+n)->s)>(retp->s))
	{
	  retp->i=(parray+n)->i;
	  retp->j=(parray+n)->j;
	  retp->s=(parray+n)->s;
	}
    }
  //printf("final (%i %i %.3f) \n",retp->i,retp->j,retp->s);
  return retp;
}

