struct cluster {
  long N; // number of members in this cluster
  long *m; // the members in this cluster
  double *d; // the link strength between this cluster and all others
};

struct pair {
  long i;
  long j;
  double s;
};

struct node {
  long i;
  double s;
};

struct cluster2 {
  long Nv; // Number of vertices
  long *v; // Vertex indices
  long Ne; // Number of edges
  struct pair *e; // Edge indices and strength
};

struct triplet {
  long i;
  long j;
  long k;
  double s;
};

struct quadraplet {
  long i;
  long j;
  long k;
  long l;
  double s;
};

struct pair2 {
  int flag;
  long i;
  long j;
  double s1;
  double s2;
};

// Recursive structure of a binary tree.
struct bintree {
  int ind;
  long val;
  int isleaf;
  struct bintree *leftchild;
  struct bintree *rightchild;
};

struct cluster3 {
  long Nv;  // Number of genes in the cluster.
  long *v;  // Gene indices.
  long Nd;  // Number of data points.
  double *avexp;  // Average expression profiles.
};

struct hiertreenode {
  long ind;  // The index of the node.
  long parent;  // The parent.
  long leftchild;  // The left child.
  long rightchild;  // The right child.
  int valid;  // Whether this node is a valid cluster at current stage.
  long Nv;  // The number of genes in the cluster.
  long *v;  // Gene indices.
  long Nd;  // The number of data points.
  double *avexp;  // Average expression profiles.
  long Nintervals;  // Number of intervals in the data.
  double *localstd;  // Relative standard deviation within each interval.
  double *localmean;  // Mean within each interval.
};
  
struct pair3 {
  long i;
  long j;
  double s1;
  double s2;
  double s3;
};
