struct clique {
  long new;     // The status of the clique.
                // 0: old, this clique was generated more than one step before.
                // 1: new, this clique was generated one step before.
                // 2: newnew, this clique is newly formed. 
  long subset;  // 0: This is not a subset of other cliques.
                // 1: This is a subset of a larger clique.
  long Nv;      // Number of vertices.
  long *v;      // Vertices indices.
};


// Representation of the history of clique evolution during the top-down clique forming process.
// Each time when an edge is added to the graph, only two types of clique formations are possible: 1. two cliques merge to one clique, 2. the end nodes of the added edge, plus the intersection of two cliques (each corresponding to a clique containing only one end node), form a new clique.
struct cliquelineage {
  long ind;      // clique index.
  long time;     // At which stage is this clique formed.
  //  int formtype;  // Clique formation type.
                 // 0: original cliques, individual nodes.
                 // 1: merge two ancestor cliques.
                 // 2: unite the intersection of two cliques and the end nodes.
  //  long Nancestors;   // Number of ancestor pairs.  One clique may evolve from different merges.
  //  struct pair *ancestors;  // Indices of the clique's ancestor cliques at previous stage.  Notice each clique (including non-maximal clique) has a distinctive index number.
  long edge[2]; // The ends of the edge added to the graph when this clique is formed. 
  //  long Nchildren; // Number of children.
  //  long *children; // Indices of children cliques.
  long Nv;        // Number of vertices.
  long *v;        // Vertices indices.
  int  ismaximal; // Whether this clique is maximal.
                  // 0: non-maximal, 1: maximal.
  int  repeated;  // 0: this clique is still useful, 1: this clique is repeated.
  double hash;
};
 

/*
// An edge.
struct edge {
  long   v1;  // End node 1.
  long   v2;  // End node 2.
  long   f1;  // Factor node 1.
  long   f2;  // Factor node 2.
  double s;   // Edge strength.
};


// Representation of a sparse graph: annotate the edges.
struct sparsegraph {
  long Ne;  // Number of edges.
  struct edge *e; // Edges.
};
*/
