// Database utility functions.

# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include "query.h"
# define MAXLINEWIDTH 1000

//char * fgets2(char *s, int length, FILE *fp, int debug);
double atof2(char *s, int length);

// Get the designated item in a string.
char * getitemval(char *s, int ind, int *length)
{
  int i, tabcnt, curind, cnt;
  char ch, *item, *template;

  
  template=malloc(sizeof(char)*MAXLINEWIDTH);
  
  tabcnt=0; curind=0;

  /*
  while ((tabcnt<ind)&&(curind<strlen(s)))
    {
      ch=*(s+curind);

      if (ch==0x09)
	tabcnt++;
      curind++;
    }
  */

  while ((tabcnt<ind)&&(curind<strlen(s)))
    {
      ch=*(s+curind);

      if (ch==0x09)
	tabcnt++;
      // If the line ends before tabcnt reaching ind, then return null.
      else if ((ch==0x0a)&&(tabcnt<ind))
	tabcnt=ind+1;
      curind++;
    }


  if (tabcnt==ind)
    {
      
      cnt=0;
      while (((ch=*(s+curind))!=0x09)&&(ch!=0x0a)&&(ch!=0x0d))
	{
	  *(template+cnt)=ch;
	  curind++; cnt++;
	}
    
      if (cnt>0)
	{
	  item=malloc(sizeof(char)*cnt);
	  for (i=0; i<=(cnt-1); i++)
	    *(item+i)=*(template+i);
	  *length=cnt;
	}
      else
	*length=cnt;
           
    }
  else
    {
      item=NULL; *length=0;
    }

  free(template);
  

  return item;
}
	

// Get the next item.
char * getnextitemval(char *s, int *length, int curpos, int *nextpos)
{
  int pos, cnt;
  char ch, *item;

  pos=curpos; cnt=0;
  while ((pos<strlen(s))&&((ch=*(s+pos))!=0x09)&&(ch!=0x0d))
    {
      cnt++; pos++; 
    }

  if (cnt==0)
    {
      *length=0; *nextpos=pos+1;
      return item;
    }
  item=malloc(sizeof(char)*cnt);
  pos=curpos; cnt=0; 
  while ((pos<strlen(s))&&((ch=*(s+pos))!=0x09)&&(ch!=0x0d))
    {
      *(item+cnt)=ch;
      cnt++; pos++;
    }
  pos++;
  *length=cnt; *nextpos=pos;
  return item;

}


// Get the next item.
char * getnextitemval2(char *s, int *length, int curpos, int *nextpos, int *end)
{
  int pos, cnt;
  char ch, *item;

  pos=curpos; cnt=0;
  while ((pos<strlen(s))&&((ch=*(s+pos))!=0x09)&&(ch!=0x0a))
    {
      // Debug
      printf("%c",ch);

      cnt++; pos++; 
    }

  if (ch==0x0a)
    *end=1;
  else
    *end=0;

  if (cnt==0)
    {
      *length=0; *nextpos=pos+1;
      return item;
    }
  item=malloc(sizeof(char)*cnt);
  pos=curpos; cnt=0; 
  while ((pos<strlen(s))&&((ch=*(s+pos))!=0x09)&&(ch!=0x0a))
    {
      *(item+cnt)=ch;
      cnt++; pos++;
    }
  pos++;
  *length=cnt; *nextpos=pos;
  return item;

}



// Convert a string into a real number.
// Also works for exponential representation.
double atof2(char *s, int length)
{
  double val, expval, power;
  int cnt, sign, afterpoint, afterexp, expsign;
  char ch;

  val=0; sign=1; cnt=0; afterpoint=0; afterexp=0; 
  expval=0, expsign=1; power=1.0;
  //while (cnt<strlen(s))
  while (cnt<length)
    {
      ch=*(s+cnt);
      if ((cnt==0)&&(ch=='-'))
	sign=-1;
      else if ((ch=='-')&&(afterexp==1))
	expsign=-1;
      else if (ch=='.')
	{
	  afterpoint=1;
	  power=0.1;
	}
      else if ((ch=='e')||(ch=='E'))
	{	
	  afterexp=1;
	  afterpoint=0;
	}
      else if ((ch>='0')&&(ch<='9')&&(afterpoint==0))
	{
	  if (afterexp==0)
	    val=val*10+(ch-'0');
	  else
	    expval=expval*10+(ch-'0');
	}
      else if ((ch>='0')&&(ch<='9')&&(afterpoint==1))
	{
	  if (afterexp==0)
	    val=val+(ch-'0')*power;
	  else
	    expval=expval+(ch-'0')*power;
	  power=power*0.1;
	}
  
      cnt++;
    }

  
  if (sign==-1)
    val=val*(-1);
  if (expsign==-1)
    expval=expval*(-1);

  val=val*pow(10,expval);

  return val;
}

