# define MAXTABLELENGTH 100
# define NMAXFIELDS 300
# define MAXFIELDLENGTH 100
# define NMAXITEMS 7000

// The querry condition phrase.
struct condphrase {
  int  phrase;  // 0: table1.field1=table2.field2, 1: table1.field1(><=) val.
  char table1[MAXTABLELENGTH]; 
  char field1[MAXFIELDLENGTH];
  char table2[MAXTABLELENGTH];
  char field2[MAXFIELDLENGTH];
  int  relation; // 0:=, 1:>, 2:<, 3:>=, 4:<=, 5:!=.
  double val;
};

// A query statement.  It contains the following components.
// (1)the index of the query field.
// (2)the relational operator (>, <, =, >=, <=, !=).
// (3)the data type of the compared value (a string or a number).
// (4)the string entity of the compared value.
// (5)the number entity of the compared value.

// Relational operator: 0-->, 1--<, 2--=, 3-->=, 4--<=, 5--!=.
struct querystatement {
  int field;  // Query field index.
  int relation; // Relational operator.
  int valtype; // Data type of the compared value.  0--string, 1--number.
  char *strval; // String entity of the compared value.
  double numval; // Number entity of the compared value.
};


// Combination of statements
struct combstatements {
  int Nstatements;
  struct querystatement *statements;
};

